% !TeX encoding = iso-8859-1
# -*- coding: utf-8 -*-
"""
Created on Sun May  4 17:03:14 2014
@author: J. Marchais
"""

"""============================================================================
Bibliothques
============================================================================"""
import numpy as np
import matplotlib.pyplot as plt
import time as time
"""============================================================================
Variables d'entre : Matrices et vecteurs
============================================================================"""
L=12.
H=3.
a1=[1.,2.,3.]    #1ere ligne de la matrice A
a2=[2.,2.,0.]    #2e ligne de la matrice A
a3=[3.,0.,6.]    #3e ligne de la matrice A
A=np.copy([a1,a2,a3])    #assemblage de la matrice A

b=[2.,-4.,0.]

"""============================================================================
Fonctions 
============================================================================"""
    
def inv_ligne(Matrice,ligne_a,ligne_b):
    memoire=np.copy(Matrice[ligne_b])
    Matrice[ligne_b]=np.copy(Matrice[ligne_a])
    Matrice[ligne_a]=np.copy(memoire)
    return Matrice

def add_ligne(Matrice,ligne_a,ligne_b,facteur):
    Matrice[ligne_a]=Matrice[ligne_a]+facteur*Matrice[ligne_b]
    return Matrice
    
def pro_mat_vec(Matrice,Vecteur):
    Resultat=np.array([0.]*len(Vecteur))
    for i in range(len(Vecteur)):
        for j in range(len(Vecteur)):
            Resultat[i]=Resultat[i]+Matrice[i][j]*Vecteur[j]
    return Resultat
    
def pro_mat_mat(Matrice_a,Matrice_b):
    ligne_0=np.array([0.]*len(Matrice_a))
    Resultat=[]
    for i in range(len(Matrice_a)):
        Resultat+=[np.copy(ligne_0)]
    for i in range(len(Matrice_a)):
        for j in range(len(Matrice_a)):
            for k in range(len(Matrice_a)):
                Resultat[i][j]=Resultat[i][j]+Matrice_a[i][k]*Matrice_b[k][j]
    return Resultat
    
def sup_ligne(Matrice,nb_col):
    #<---> completer
    return (nb_ligne)
    
def pivot_gauss(A):
    for i in range(len(A)):
        n_l=sup_ligne(A,i)
        coef_i=A[n_l][i]
        if coef_i==0:
            print('matrice singuliere')
            return A
        A=inv_ligne(A,i,n_l)
        A[i]=A[i]/coef_i
        for j in range(len(A)):
            if j!=i:
                coef=-A[j][i]
                A=add_ligne(A,j,i,coef)
    return A
"""============================================================================
Main
============================================================================"""









        
